import React from 'react';
import { ListProps } from '../list/useList';
import { RouteComponentProps } from 'react-router';
import List from '310-logic/component/List';
interface NavigationConfig<P extends ListProps = ListProps> {
    component: React.ComponentClass<P> | React.FunctionComponent<P>;
}
interface NavigationProps extends List, RouteComponentProps {
}
declare const navigation: ({ component: Navigator }: NavigationConfig<ListProps>) => React.MemoExoticComponent<React.ComponentClass<Pick<NavigationProps, "items" | "type" | "name" | "select" | "variant" | "view">, any>>;
export default navigation;
export { NavigationProps };
