var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import React from 'react';
import useList from '../list/useList';
import { withRouter } from 'react-router';
import selector from '../list/selector';
import { GROUP } from '310-logic/component/Group';
var find = function (source) { return function (match) {
    var path = [];
    var stack = [[-1, source]];
    do {
        var _a = stack.pop(), prev = _a[0], items = _a[1];
        var i = prev + 1;
        for (; i < items.length; i++) {
            var link = items[i];
            if (link.path === match) {
                path = stack.map(function (tupple) { return tupple[0]; });
                // signal loops exit
                i = items.length;
                stack.length = 0; // or stack.splice(0, stack.length);
            }
            else if (link.type === GROUP) {
                stack.push([i, items]);
                stack.push([0, link.items]);
            }
        }
    } while (stack.length > 0);
    return path;
}; };
var navigation = function (_a) {
    var Navigator = _a.component;
    return React.memo(withRouter(function (_a) {
        var history = _a.history, location = _a.location, match = _a.match, items = _a.items, staticContext = _a.staticContext, config = __rest(_a, ["history", "location", "match", "items", "staticContext"]);
        var _b = React.useState(find(items)(location.pathname)), active = _b[0], save = _b[1];
        var select = selector(items);
        var setActive = function (path) {
            save(path);
            var link = select(path);
            if (link && (link.path || link.to)) {
                console.log('navigate to', link.path, link.to);
                history.push(link.path, link.to);
            }
        };
        var props = useList(__assign({ active: active, disabled: [], highlighted: [], items: items,
            setActive: setActive }, config));
        return (React.createElement(Navigator, __assign({}, config, props)));
    }));
};
export default navigation;
//# sourceMappingURL=../../src/dist/factories/navigation.js.map