import Item from '310-logic/component/Item';
import React from 'react';
import { ListProps } from '../list/useList';
import { FormFields } from './Form';
interface SelectProps<P extends ListProps = ListProps> {
    component: React.ComponentClass<P> | React.FunctionComponent<P>;
    config: Record<string, any>;
    fields: FormFields;
    name: string;
    setField: (fields: FormFields) => void;
    source: Item[];
}
declare const Select: React.MemoExoticComponent<({ component: List, config, fields, name, setField, source }: SelectProps<ListProps>) => JSX.Element>;
export default Select;
