var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import useList from '../list/useList';
var Select = React.memo(function (_a) {
    var List = _a.component, config = _a.config, fields = _a.fields, name = _a.name, setField = _a.setField, source = _a.source;
    var value = fields[name] || '';
    var props = useList({
        active: value.length ? value.split('|').map(function (s) { return Number(s); }) : [],
        disabled: [],
        highlighted: [],
        items: source,
        setActive: function (value) {
            var _a;
            return setField((_a = {}, _a[name] = value.join('|'), _a));
        },
        variant: fields.variant,
        view: fields.view
    });
    return (React.createElement(List, __assign({}, config, props)));
});
export default Select;
//# sourceMappingURL=../../src/dist/form/SelectField.js.map